
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>基于Eclipse的Android JNI层测试应用开发过程记录 / 憋错料</title>

    <meta name="description" content="基于Eclipse的Android JNI层测试应用开发过程记录 前言 本文记录一个Java层与JNI层参数与数据交互的应用程序开发过程,为实现一个功能完整的带Java与JNI的应用程序打下基础.本文假设读者已搭建好Android的Eclipse与NDK开发环境,包括通过ADB连接手机的配置. 1. 构建基本的Android应用程序 1.1 引导界面配置 打开Eclipse,&quot;File&quot;-&gt;&quot;New&quot;-&gt;&quot;Android Application Project&quot;,在弹出界面,配置如下(红色 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">基于Eclipse的Android JNI层测试应用开发过程记录</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1><strong>前言</strong></h1>
<p>　　本文记录一个Java层与JNI层参数与数据交互的应用程序开发过程，为实现一个功能完整的带Java与JNI的应用程序打下基础。本文假设读者已搭建好Android的Eclipse与NDK开发环境，包括通过ADB连接手机的配置。</p>
<h1><strong>1. 构建基本的Android应用程序</strong></h1>

<h2>1.1&nbsp;<strong>引导界面配置</strong></h2>
<p><strong></p>
<p></strong></p>
<p>　　打开Eclipse，&quot;File&quot;-&gt;&quot;New&quot;-&gt;&quot;Android<br />
 Application Project&quot;，在弹出界面，配置如下(红色框表示不是默认，是作者修改过的地方，下同)：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MTIyMTQzMjQ1NDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WTJ4dmRXUmZaR1Z6YTNSdmNBPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>　　之后，一路点击&quot;Next &gt;&quot;，直到&quot;Finish&quot;。点击&quot;Finish&quot;之后，自动回打开如下界面：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MTIyMTQ3MjgyODE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WTJ4dmRXUmZaR1Z6YTNSdmNBPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>　　</p>
<h2><strong>1.2 XML文件配置</strong></h2>
<p>　　我们可以看到一个虚拟的应用界面，其中有一行文字&quot;Hello<br />
 world!&quot;。点击上图右下角的activity_main.xml，其中有如下定义：</p>
<pre>    &lt;TextView
        android:layout_width=&quot;wrap_content&quot;
        android:layout_height=&quot;wrap_content&quot;
        android:text=&quot;@string/hello_world&quot; /&gt;</pre>
<p>　　其中的字符串就定义在res文件夹下values文件夹中的strings.xml中。我们对hello_world的&#20540;做修改，如下：</p>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;
&lt;resources&gt;

    &lt;string name=&quot;app_name&quot;&gt;app&lt;/string&gt;
    &lt;string name=&quot;action_settings&quot;&gt;Settings&lt;/string&gt;
    &lt;string name=&quot;hello_world&quot;&gt;Napolean: Hello Android Application!&lt;/string&gt;

&lt;/resources&gt;</pre>
<p>　　根据需要，可以将上图中模拟应用界面的左边栏中的控件拖入模拟应用界面上放置，相应地，XML文件中就会有该控件的布局描述。</p>
<p><strong>1.3 运行应用程序</strong></p>
<p>　　可以再src目录下有个MainActivity.java，这是上面引导界面配置完成后自动生成的代码。</p>
<pre>package com.napolean.app;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}</pre>
<p>　　插入手机连接上ADB，或者配置一个Android模拟器，点击运行程序，即可看到应用程序运行并显示我们所修改的字符串。关于手机如何通过ADB连接以及Android模拟器的配置，在此不作展开。</p>
<h1><strong>2. 构建Java与C/C&#043;&#043;交互的JNI层接口</strong></h1>
<p>　　Java与C/C&#043;&#043;交互分为两边：一边是Java层：在Java层的类中声明本地接口函数，并在公共接口函数调用，使得需要访问JNI层函数的类调用这些公共函数即可；另一边是JNI层：JNI层有对应于Java层中本地函数的对应函数，也有其它普通函数，在Java层本地函数被调用时，实际上最终会执行对应的C/C&#043;&#043;层函数。</p>
<h2>2.1 Java层包含JNI本地函数的类</h2>
<p>　　</p>
<p>　　右键点击src目录下的com.napolean.app，选择&quot;New&quot;-&gt;&quot;Class&quot;，在弹出的界面中输入类名&quot;NativeInterface&quot;，&quot;Finish&quot;即可完成NativeInterface类的创建。在生成的NativeInterface.java中的空类NativeInterface中添加Native函数及其封装的公共接口，具体代码如下：</p>
<pre>package com.napolean.app;

public class NativeInterface {

	private native void native_init();
	private native void native_exit();

	private native byte[] native_process(byte[] in_buffer, int width, int height);

	public void NativeInit() {
		native_init();
	}

	public void NativeExit() {
		native_exit();
	}

	public void NativeProcess(byte[] in_buffer, int width, int height)
	{
		native_process(in_buffer, width, height);
	}

	static {
        	System.loadLibrary(&quot;NativeInterface&quot;);
    	}

}</pre>
<p>　　所创建的Native函数有初始化函数、退出函数和处理函数。其中处理函数包含输入字节流、Buffer宽度、Buffer高度，返回处理后的字节流。接下来三个函数分别是三个Native函数的公共接口。</p>
<p>　　最后在static中调用System.loadLibrary()，其中引号内为后面JNI层动态库库名。实际生成的动态库名会在Android.mk中指定的库名前添加lib之后添加.so，即声明为xxx的库，最终生成libxxx.so。&#20540;得注意的是：在上述加载函数中必须使用xxx而不能使用全名，并且在Android中指定的库名不能带lib前缀，否则无法加载。</p>
<h2>2.2 本地函数在JNI层的实现</h2>
<p>　　首先创建jni文件夹：右键点击工程名，&quot;New&quot;-&gt;&quot;Folder&quot;，输入&quot;jni&quot;，创建jni文件夹。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MTMyMjA1NDgwMzE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WTJ4dmRXUmZaR1Z6YTNSdmNBPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>　　接着，在终端输入javah命令，创建根据NativeInterface中声明native函数对应的JNI层函数接口，在工程根目录下具体命令为</p>
<pre>javah -classpath bin/classes -d jni com.napolean.app.NativeInterface</pre>
<p>　　运行命令后，在jni文件夹下就会生成一个名为com_napolean_app_NativeInterface.h的头文件，里面包含有的接口函数如下：</p>
<pre>/* DO NOT EDIT THIS FILE - it is machine generated */
#include &lt;jni.h&gt;
/* Header for class com_napolean_app_NativeInterface */

#ifndef _Included_com_napolean_app_NativeInterface
#define _Included_com_napolean_app_NativeInterface
#ifdef __cplusplus
extern &quot;C&quot; {
#endif
/*
 * Class:     com_napolean_app_NativeInterface
 * Method:    native_init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_napolean_app_NativeInterface_native_1init
  (JNIEnv *, jobject);

/*
 * Class:     com_napolean_app_NativeInterface
 * Method:    native_exit
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_napolean_app_NativeInterface_native_1exit
  (JNIEnv *, jobject);

/*
 * Class:     com_napolean_app_NativeInterface
 * Method:    native_process
 * Signature: ([BII)[B
 */
JNIEXPORT jbyteArray JNICALL Java_com_napolean_app_NativeInterface_native_1process
  (JNIEnv *, jobject, jbyteArray, jint, jint);

#ifdef __cplusplus
}
#endif
#endif
</pre>
<p>　　生成这个头文件的目的是免去手动编写JNI层的接口函数，并无其它用途，使用后可删除。在jni文件夹下创建NativeInterface.cpp，将上述头文件中所有内容拷入，经过改造，如下：</p>
<pre>#include &lt;jni.h&gt;
#include &lt;android/log.h&gt;

#define LOG_TAG &quot;APP&quot;
#define LOGI(...) __android_log_print(ANDROID_LOG_INFO, LOG_TAG, __VA_ARGS__)
#define LOGE(...) __android_log_print(ANDROID_LOG_ERROR, LOG_TAG, __VA_ARGS__)

#ifndef _Included_com_napolean_app_NativeInterface
#define _Included_com_napolean_app_NativeInterface

#ifdef __cplusplus
extern &quot;C&quot; {
#endif

/*
 * Class:     com_napolean_app_NativeInterface
 * Method:    native_init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_napolean_app_NativeInterface_native_1init
  (JNIEnv *, jobject)
{
	LOGI(&quot;APP native init.&quot;);
}

/*
 * Class:     com_napolean_app_NativeInterface
 * Method:    native_exit
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_napolean_app_NativeInterface_native_1exit
  (JNIEnv *, jobject)
{
	LOGI(&quot;APP native exit.&quot;);
}

/*
 * Class:     com_napolean_app_NativeInterface
 * Method:    native_process
 * Signature: ([BII)[B
 */
JNIEXPORT jbyteArray JNICALL Java_com_napolean_app_NativeInterface_native_1process
  (JNIEnv *, jobject, jbyteArray, jint, jint)
{
	LOGI(&quot;APP native process.&quot;);

}

#ifdef __cplusplus
}
#endif
#endif
</pre>
<p>　　上述改造的代码主要是将函数声明改为函数定义，并且添加了打印信息的支持。</p>
<h2>2.3 JNI层动态库编译配置</h2>
<p>　　如果你亲手创建工程，就会发现头文件和函数定义的字符下面有黄色下划线，这是因为Eclipse找不到jni.h和android/log.h的头文件。所以需要在Eclipse配置JNI层特有的头文件路径。</p>
<p>　　第一步，添加C/C&#043;&#043;特性。右键点击jni文件夹，&quot;New&quot;-&gt;&quot;Other&quot;，在弹出界面如下选择：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MTMyMjMxNDA3MDM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WTJ4dmRXUmZaR1Z6YTNSdmNBPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>在下一个界面中的指定工程类型中选择&quot;Shared<br />
 Library&quot;(这一步并不重要，因为后面需要修改编译工具)，点击&quot;Finish&quot;，Eclipse就开始转换工作。</p>
<p>　　第二步，修改编译工具。右键点击工程名，&quot;Properties&quot;，弹出如下界面，其中左边栏中的&quot;C/C&#043;&#043;<br />
 Build&quot;与&quot;C/C&#043;&#043; General&quot;是上一步转换工作完成后新的。选择&quot;C/C&#043;&#043; Build&quot;，在&quot;Builder Settings&quot;标签中，去掉&quot;Use default build command&quot;前的勾，输入&quot;ndk-build&quot;，点击&quot;Apply&quot;应用，如下所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MTMyMjQyMjA5MDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WTJ4dmRXUmZaR1Z6YTNSdmNBPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>　　第三步，配置头文件路径。在&quot;C/C&#043;&#043;<br />
 General&quot;-&gt;&quot;Paths and Symbols&quot;-&gt;&quot;Includes&quot;-&gt;&quot;GNU C&#043;&#043;&quot;中添加头文件路径。点击右边的&quot;Add...&quot;，添加四个路径，然后点击&quot;Apply&quot;应用。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MTMyMjU0NTI4MTI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WTJ4dmRXUmZaR1Z6YTNSdmNBPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>其中，四个头文件路径为：</p>
<pre>/home/work/android/android-ndk-r9/platforms/android-18/arch-arm/usr/include/
/home/work/android/android-ndk-r9/sources/cxx-stl/gnu-libstdc++/4.6/include/
/home/work/android/android-ndk-r9/sources/cxx-stl/gnu-libstdc++/4.6/libs/armeabi-v7a/include/
/home/work/android/android-ndk-r9/toolchains/arm-linux-androideabi-4.6/prebuilt/linux-x86/lib/gcc/arm-linux-androideabi/4.6/include/</pre>
<p>　　第四步，创建Android.mk。右键点击jni文件夹，&quot;New&quot;-&gt;&quot;File&quot;，输入Android.mk。添加如下代码：</p>
<pre>LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

LOCAL_MODULE    := NativeInterface
LOCAL_SRC_FILES := NativeInterface.cpp

LOCAL_LDLIBS := -llog

include $(BUILD_SHARED_LIBRARY)</pre>
<p>　　第五步，编译生成动态库。点击Eclipse菜单栏中的&quot;Project&quot;-&gt;&quot;Build Project&quot;，即可完成编译。在libs/armeabi/文件夹下生成了&quot;libNativeInterface.so&quot;动态库。</p>
<h2>2.4 Java层中调用本地函数</h2>
<p>　　Java层调用JNI层本地函数的方法，如下所示。</p>
<pre>package com.napolean.app;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;

public class MainActivity extends Activity {

	private NativeInterface myJNI;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		byte[] in_buffer = new byte[1920*1080*3/2];
		int width = 1920;
		int height = 1080;

		myJNI = new NativeInterface();

		myJNI.NativeInit();
		myJNI.NativeProcess(in_buffer, width, height);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	protected void onDestroy() {
		myJNI.NativeExit();
		super.onDestroy();
	}

}
</pre>
<h1>附录：更多内容</h1>
<p>　　参见我的ChinaUnix博客文章：<a href="http://blog.chinaunix.net/uid-20746260-id-3910616.html" rel="external nofollow noreferrer">http://blog.chinaunix.net/uid-20746260-id-3910616.html</a></p>
<p><strong></p>
<p></strong></p>
<p><P><A href="http://www.bubuko.com/infodetail-236304.html" rel="external nofollow noreferrer">基于Eclipse的Android JNI层测试应用开发过程记录,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 16:09:19 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/android/" title="android">android</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>基于Eclipse的Android JNI层测试应用开发过程记录的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41zDJJM.html" rel="bookmark">基于Eclipse的Android JNI层測试应用开发过程记录</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 本文记录一个Java层与JNI层參数与数据交互的应用程序开发过程.为实现一个功能完整的带Java与JNI的应用程序打下基础. 本文如果读者已搭建好Android的Eclipse与NDK开发环境,包含通过ADB连接手机的配置. 1. 构建主要的Android应用程序 1.1 引导界面配置 打开Eclipse,&quot;File&quot;-&gt;&quot;New&quot;-&gt;&quot;Android Application Project&quot;,在弹出界面,配置例如以下(红色框表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JD5QA0.html" rel="bookmark">Android Jni层 创建 linux socket 出错问题解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题: 想在Jni层创建 udp socket 与服务端通信,但是没有成功,最后发现竟然是创建socket失败(代码如下) // create socket g_sd = socket(AF_INET, SOCK_DGRAM, 0); if (-1 == g_sd) { perror(&quot;socket()&quot;); goto err_socket; } 解决办法: 在 AndroidManifest.xml 文件中,添加访问网络的权限: &lt;uses-permission android			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MX1eEV0.html" rel="bookmark">基于eclipse搭建android开发环境-win7 32bit</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于eclipse搭建android开发环境-win7 32bit 前言:在使用朋友已搭建的Android开发环境时,发现朋友的开发环境版本较低且在update SDk时失败,便决定根据网上文章提示从头搭建一全新的Android开发环境. 1.准备工作 下载Eclipse.JDK(7).Android SDK.ADT插件. 地址: eclipse:http://www.eclipse.org/downloads/ 版本:Luna Service Release 1 (4.4.1) jdk:htt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MznkJlM.html" rel="bookmark">Mac OS下基于Eclipse的Android调试环境搭建</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.安装Eclipse:http://www.eclipse.org/downloads/,网页会自动检测适用的版本(Mac OS x64),下载“Eclipse IDE for java Developers”并安装: 2.尝试运行Eclipse,若提示“您需要安装旧 Java SE 6 运行环境才能打开”,则点击弹出对话框里面的“详情”,跳转到苹果官网的指定页面(如:https://support.apple.com/kb/DL1572?locale=zh_CN),下载需要的文件并安装: 3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmeXNDM.html" rel="bookmark">Android JNI层确保只有一个进程的一个实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有时需要在Android的C层中创建一个新的进程比如myServer,但是我们又不希望,同一时间有多个myServer存在. 本文介绍个方法,相当于在在后台执行&quot;ps myServer&quot;,获取结果,进行分析,在主线程中调用. 查询一个名为myServer的进程是否存在可以这么使用: getMyPid(); 查询失败返回-1,没有这个进程返回0,如果进程存在就返回该进程的pid. 以下是代码实现. int pidIndex(const char* szData) {      char 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QjGvLM.html" rel="bookmark">Android JNI用于驱动测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				硬件平台:S3C6410 操作系统:Ubuntu.windows 板子系统:Android 开发工具:jdk,ndk,eclipse 本次测试从linux内核模块编译开始,以S3C6410的pwm驱动为例. pwm_6410.c: #include &lt;linux/module.h&gt; #include &lt;linux/kernel.h&gt; #include &lt;linux/fs.h&gt; #include &lt;linux/init.h&gt; #include &lt;linu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YykJO0.html" rel="bookmark">Android framework层JNI的使用浅析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				尊重原创:http://blog.csdn.net/yuanzeyao/article/details/42418977 JNI技术对于多java开发的朋友相信并不陌生,即(java native interface),本地调用接口,主要功能有以下两点: 1.java层调用C/C++层代码 2.C/C++层调用java层代码 可能有些人会觉得jni技术破坏了Java语言的跨平台性,有这种想法可能是因为你对java理解得还不够深,如果你看看jdk源码,你会发现在jdk里面大量使用了jni技术,而且			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pRWXw0.html" rel="bookmark">Android JNI programming demo with Eclipse</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用Eclipse 建立 JNI 的專案, 示範如何在 JAVA 調用 cpp 的函數. 我們將建立一個名稱為 jnidemo的專案, 在主Activity 將調用一個名為libHello.so 的 cpp 函數庫的 getVersion() 的函數, 將其返回字串寫在主Activity 的TextView 上. 首先用Eclipse建立一個新的 Android Activity 專案.  其他選項都用預設值就可以. 1. 稍微修改主活動配置 layout/activity_main.xml, 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vQOyk0.html" rel="bookmark">Android中关于JNI 的学习（三）在JNI层访问Java端对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面两篇文章简单介绍了JNI层跟Java层的一些对应关系,包括方法名,数据类型和方法名称等,相信在理论层面,能够很好地帮助我们去了解JNI在Native本地开发中的作用,对JNI的一些概念也有了一个初步的认识,由于表达能力或者理解还是有限,有些地方讲得不是很清楚,如果各位朋友有觉得云里雾里,欢迎大家留言一起学习. 概念上的理解有助于我们更好地认识JNI,而一些实际点的例子则能够更好地帮我们从代码上去掌握并应用JNI. 在第一篇文章,我们是从一个小例子来入门学习的,在其中,我们通过JNI层函数返回			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDRXmp3.html" rel="bookmark" class="title">Delphi中如何获取TDateTimePicker控件的属性值</a>
					<div>
						参考资料:http://www.delphipages.com/forum/showthread.php?t=103412 var dtpDate: TDateTimePicker; begin dt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzajZ24.html" rel="bookmark" class="title">关于wav文件fft处理后x&comma;y轴坐标数据的问题</a>
					<div>
						1.关于横坐标的频率的最大值是采样频率,那么每个点对应的频率值就很好算了:f(n) = [Fs/(N/2)]*n  (Fs是采样频率,常见的是44.1KHz(44100),N是采样点数,k表是第k个点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lrE5L4.html" rel="bookmark" class="title">经济64&period;&period;&period;７７</a>
					<div>
						从2014年4月证券B以1元的价格开始上市交易到2014年12月17日,复权价最高涨到了6.5元,涨了500%+!但随后出现了一波非常恐怖的下跌,到2015年2月3日最低跌到只有3.9,跌幅达到40% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONxpP0.html" rel="bookmark" class="title">&lbrack;email&amp;&num;160&semi;protected&rsqb;一个有效的配置管理工具--Ansible configure management--翻译（十二）</a>
					<div>
						如果没有书面授权,请勿转载 第五章 自己定义模块 External inventories In the first chapter we saw how Ansible needs an inven ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bOddm3.html" rel="bookmark" class="title">每日一小练&mdash;&mdash;数值自乘非递归解</a>
					<div>
						上得厅堂,下得厨房,写得代码,翻得围墙,欢迎来到睿不可挡的每日一小练! 题目:数值自乘非递归解 内容: 连续求m^n问题(m与n是正整数).前面的提示会得到一个递归程序,请编写一个运算效率同样高的非递 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylG8V4.html" rel="bookmark" class="title">Git修改提交注释</a>
					<div>
						修改本地最近一次已提交的注释 git commit --amend 如果已经上传到了github上,因此github的提交和已修改的提交不一样,推送到远程可以用下面命令强制修改 git push or ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZA6bM.html" rel="bookmark" class="title">C&plus;&plus;标准转换运算符reinterpret&lowbar;cast</a>
					<div>
						文章出处:http://www.cnblogs.com/ider/archive/2011/07/30/cpp_cast_operator_part3.html reinterpret_cast &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWjXQ3.html" rel="bookmark" class="title">网络丢包严重的解决办法</a>
					<div>
						强制10M 全双工					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZe7a3.html" rel="bookmark" class="title">模拟Spring中applicationContext&period;xml配置文件初始化bean的过程</a>
					<div>
						package com.xiaohao.action; import java.io.File; import java.lang.reflect.Method; import java.util.C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQYbxM.html" rel="bookmark" class="title">Some perl tips</a>
					<div>
						下面是日常工作中一些代码片段的总结,部分注释是后加的,采用了//这种形式,请勿套用. 1.取得用户输入print(&quot;Please input the date range:&quot;);$ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rn2PP0.html" rel="bookmark" class="title">《音乐商店》第3集：控制器</a>
					<div>
						在典型的 Web 应用中,用户请求的 URL 地址通常映射到保存在网站中的文件上,例如,当用户请求 /Products.aspx 的时候,或者 /Products.php 的时候,很可能是在通过处理  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JvPY94.html" rel="bookmark" class="title">vsftpd java程序无法创建和切换目录</a>
					<div>
						# Example config file /etc/vsftpd/vsftpd.conf # # The default compiled in settings are fairly parano ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJzbP3.html" rel="bookmark" class="title">Openstack-HA部署方案</a>
					<div>
						构建OpenStack的高可用性(HA,High Availability) 集群并不就是高可靠,常用的构建高可靠的mysql的方法有Active-passive主备模式:使用DRBD实现主备机的灾容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rm1rPM.html" rel="bookmark" class="title">jQuery noConflict</a>
					<div>
						引入jQuery文件会引入两个全局变量  $ 和 jQuery 也就是说 如果引入jQuery文件之前这两个变量 已有值的话  那就会被jQuery覆盖掉 为了解决这个问题 jQuery提供了一个no ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPeobM.html" rel="bookmark" class="title">SQL SELECT INTO使用</a>
					<div>
						SQL SELECT INTO 语句可用于创建表的备份复件. SELECT INTO 语句 SELECT INTO 语句从一个表中选取数据,然后把数据插入另一个表中. SELECT INTO 语句常用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47zqPo3.html" rel="bookmark" class="title">Linux系统特殊权限</a>
					<div>
						特殊权限 Linux权限管理 unix/linux系统中认为一切皆文件,而权限就是对用户访问和修改系统文件范围的界定规则. Linux系统权限模型: 针对用户分为:u, g, o 根据日常对文件的操作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQOeg0.html" rel="bookmark" class="title">C&num; Winform App 获取当前路径</a>
					<div>
						直接双击执行 D:\test1.exeSystem.Diagnostics.Process.GetCurrentProcess().MainModule.FileName D:\Test1.exe S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQbaXM.html" rel="bookmark" class="title">数据库设计和使用的一些常用好习惯</a>
					<div>
						好的习惯,需要不断的培养和强化,直到成为一种习惯,然后成为思想的一部分. 上班前或者下班后,有空我都要给我家小家伙读一读&lt;三字经&gt;或者&lt;弟子规&gt;,他可能并不懂这些文字的内容,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MynyZa0.html" rel="bookmark" class="title">7月第3周中国&period;NET域名净增3792个 美国净减1&period;3万个</a>
					<div>
						IDC评述网(idcps.com)07月24日报道:据WebHosting.info公布的最新数据显示,在7月第3周,中国.NET域名总量有841,115个,净增3,792个,环比涨幅增大.另外在十强 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q8xmG0.html" rel="bookmark" class="title">PHP程序员如何保护身体</a>
					<div>
						定时睡觉,按需求起床. 很 少有什么事是必须晚上干不能早上干的,至少非工作的写代码看文档肯定不是.以前上学的时候我的习惯就是早上起来写代码.如果时间紧可能12点睡4点起,个 人感觉比4点睡8点起效率更 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
